W_kSummaryHealthBarWidth = 100;
W_kSummaryHealthBarHeight = 3;
W_kSummaryManaBarWidth = 100;
W_kSummaryManaBarHeight = 3;

function WhammySummary_OnLoad(self)	
	WhammySummaryFrame_HealthBar:SetWidth( W_kSummaryHealthBarWidth );
	WhammySummaryFrame_HealthBar:SetHeight( W_kSummaryHealthBarHeight );
	
	WhammySummaryFrame_ManaBar:SetWidth( W_kSummaryManaBarWidth );
	WhammySummaryFrame_ManaBar:SetHeight( W_kSummaryManaBarHeight );
end

function WhammySummary_MouseDown( self, ... )
	local arg1 = ...;
	if ( arg1 == "LeftButton" ) then -- drag the frame
		self:StartMoving();
	end
end

function WhammySummary_MouseUp(self)
	self:StopMovingOrSizing();
end



-- called when there is a health changed event to update the party/raid total health bar
function WS.Update_Total_Health()
	local bar = WhammySummaryFrame_HealthBar
	local numGroupMembers = GetNumGroupMembers();
	local currentUnitHealth, maxUnitHealth, healthFraction = 0,0,0; --need to init these to 0
	
	local playerGroupStatus = W.GetPlayerGroupStatus(); --will return kPlayerAlone, kPlayerInParty or kPlayerInRaid
	
	if ( playerGroupStatus == kPlayerAlone ) then
		currentUnitHealth = UnitHealth( "player" ); --get the current player unit health
		maxUnitHealth = UnitHealthMax( "player" ); --get the units max health
	elseif ( playerGroupStatus == kPlayerInParty ) then
		currentUnitHealth = UnitHealth( "player" ); --get the current player unit health
		maxUnitHealth = UnitHealthMax( "player" ); --get the units max health
			
		for id = 1,numGroupMembers do --walk through the other party members and gather their max and current health
			currentUnitHealth = currentUnitHealth + UnitHealth( "party"..id ); --get the current unit health
			maxUnitHealth = maxUnitHealth + UnitHealthMax( "party"..id ); --get the units max health
		end
	elseif ( playerGroupStatus == kPlayerInRaid ) then
		for id = 1,numGroupMembers do
			currentUnitHealth = currentUnitHealth + UnitHealth( "raid"..id ); --get the current unit health
			maxUnitHealth = maxUnitHealth + UnitHealthMax( "raid"..id ); --get the units max health
		end
	else
		--should never get here
		
	end
	
	healthFraction = currentUnitHealth / maxUnitHealth; -- what % health are all the units at added together
	healthBarAmount = W_kSummaryHealthBarWidth * healthFraction;
	bar:SetWidth( healthBarAmount ); -- set the raid health bar to the raid health amount
end

function WS.Event_UnitMana()
	local bar = WhammySummaryFrame_ManaBar
	local numGroupMembers = GetNumGroupMembers();
	local currentUnitMana, maxUnitMana, manaFraction = 0,0,0;
	local unitCount = 0; --need to set this to 0 so it is not nil
	local kMana = 0; -- power type, mana=0, rage=1, focus=2(hunterpets), energy=3, happiness=4
	
	local playerGroupStatus = W.GetPlayerGroupStatus(); --will return kPlayerAlone, kPlayerInParty or kPlayerInRaid
	
	if ( playerGroupStatus == kPlayerAlone ) then
		if ( UnitPowerType("player") == kMana ) then --if this player uses mana then we will be counting it toward the total
			currentUnitMana = UnitMana( "player" ); --get the current player unit mana
			maxUnitMana = UnitManaMax( "player" ); --get the units max mana
			unitCount = 1;
		end
	elseif ( playerGroupStatus == kPlayerInParty ) then
		if ( UnitPowerType( "player" ) == kMana ) then --we only care about units that use mana
			currentUnitMana = UnitMana( "player" ); --get the current player unit mana
			maxUnitMana = UnitManaMax( "player" ); --get the units max mana
			unitCount = 1;
		end
			
		for id = 1,numGroupMembers do --walk through and see if any of the other party members use mana
			entity = "party"..id
			if ( UnitPowerType( entity ) == kMana ) then --we only care about units that use mana
				currentUnitMana = currentUnitMana + UnitMana( entity ); --get the current unit mana
				maxUnitMana = maxUnitMana + UnitManaMax( entity ); --get the units max mana
				unitCount = unitCount + 1;
			end
		end
	elseif ( playerGroupStatus == kPlayerInRaid ) then
		for id = 1,numGroupMembers do
			entity =  "raid"..id
			if ( UnitPowerType( entity ) == kMana ) then --we only care about units that use mana
				currentUnitMana = currentUnitMana + UnitMana( entity ); --get the current unit mana
				maxUnitMana = maxUnitMana + UnitManaMax( entity ); --get the units max mana
				unitCount = unitCount + 1;
			end
		end
	else
		--should never get here
		
	end

	if ( unitCount > 0 ) then -- if unit count = 0 then this player is alone and does not use mana, so the mana bar will just reset to full width
		manaFraction = currentUnitMana / maxUnitMana; -- what % mana of everyone that uses mana
		manaBarAmount = W_kSummaryManaBarWidth * manaFraction;
		bar:SetWidth( manaBarAmount ); -- set the raid mana bar to the raid mana amount
	else
		bar:SetWidth( W_kSummaryManaBarWidth ); -- set the raid mana bar to the raid mana amount
	end
end
